Merge branch 'dr/ceiling'
[git/git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # Keep the original TERM for say_color
7 ORIGINAL_TERM=$TERM
8
9 # For repeatability, reset the environment to known value.
10 LANG=C
11 LC_ALL=C
12 PAGER=cat
13 TZ=UTC
14 TERM=dumb
15 export LANG LC_ALL PAGER TERM TZ
16 EDITOR=:
17 VISUAL=:
18 unset GIT_EDITOR
19 unset AUTHOR_DATE
20 unset AUTHOR_EMAIL
21 unset AUTHOR_NAME
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
24 unset EMAIL
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26 unset GIT_AUTHOR_DATE
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
32 unset GIT_DIFF_OPTS
33 unset GIT_DIR
34 unset GIT_WORK_TREE
35 unset GIT_EXTERNAL_DIFF
36 unset GIT_INDEX_FILE
37 unset GIT_OBJECT_DIRECTORY
38 unset GIT_CEILING_DIRECTORIES
39 unset SHA1_FILE_DIRECTORIES
40 unset SHA1_FILE_DIRECTORY
41 GIT_MERGE_VERBOSITY=5
42 export GIT_MERGE_VERBOSITY
43 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
45 export EDITOR VISUAL
46 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
47
48 # Protect ourselves from common misconfiguration to export
49 # CDPATH into the environment
50 unset CDPATH
51
52 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
53 1|2|true)
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
58 ;;
59 esac
60
61 # Each test should start with something like this, after copyright notices:
62 #
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM=$ORIGINAL_TERM &&
69 export TERM &&
70 [ -t 1 ] &&
71 tput bold >/dev/null 2>&1 &&
72 tput setaf 1 >/dev/null 2>&1 &&
73 tput sgr0 >/dev/null 2>&1
74 ) &&
75 color=t
76
77 while test "$#" -ne 0
78 do
79 case "$1" in
80 -d|--d|--de|--deb|--debu|--debug)
81 debug=t; shift ;;
82 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83 immediate=t; shift ;;
84 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85 export GIT_TEST_LONG=t; shift ;;
86 -h|--h|--he|--hel|--help)
87 help=t; shift ;;
88 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89 verbose=t; shift ;;
90 -q|--q|--qu|--qui|--quie|--quiet)
91 quiet=t; shift ;;
92 --no-color)
93 color=; shift ;;
94 --no-python)
95 # noop now...
96 shift ;;
97 *)
98 break ;;
99 esac
100 done
101
102 if test -n "$color"; then
103 say_color () {
104 (
105 TERM=$ORIGINAL_TERM
106 export TERM
107 case "$1" in
108 error) tput bold; tput setaf 1;; # bold red
109 skip) tput bold; tput setaf 2;; # bold green
110 pass) tput setaf 2;; # green
111 info) tput setaf 3;; # brown
112 *) test -n "$quiet" && return;;
113 esac
114 shift
115 echo "* $*"
116 tput sgr0
117 )
118 }
119 else
120 say_color() {
121 test -z "$1" && test -n "$quiet" && return
122 shift
123 echo "* $*"
124 }
125 fi
126
127 error () {
128 say_color error "error: $*"
129 trap - exit
130 exit 1
131 }
132
133 say () {
134 say_color info "$*"
135 }
136
137 test "${test_description}" != "" ||
138 error "Test script did not set test_description."
139
140 if test "$help" = "t"
141 then
142 echo "$test_description"
143 exit 0
144 fi
145
146 exec 5>&1
147 if test "$verbose" = "t"
148 then
149 exec 4>&2 3>&1
150 else
151 exec 4>/dev/null 3>/dev/null
152 fi
153
154 test_failure=0
155 test_count=0
156 test_fixed=0
157 test_broken=0
158 test_success=0
159
160 die () {
161 echo >&5 "FATAL: Unexpected exit with code $?"
162 exit 1
163 }
164
165 trap 'die' exit
166
167 # The semantics of the editor variables are that of invoking
168 # sh -c "$EDITOR \"$@\"" files ...
169 #
170 # If our trash directory contains shell metacharacters, they will be
171 # interpreted if we just set $EDITOR directly, so do a little dance with
172 # environment variables to work around this.
173 #
174 # In particular, quoting isn't enough, as the path may contain the same quote
175 # that we're using.
176 test_set_editor () {
177 FAKE_EDITOR="$1"
178 export FAKE_EDITOR
179 VISUAL='"$FAKE_EDITOR"'
180 export VISUAL
181 }
182
183 test_tick () {
184 if test -z "${test_tick+set}"
185 then
186 test_tick=1112911993
187 else
188 test_tick=$(($test_tick + 60))
189 fi
190 GIT_COMMITTER_DATE="$test_tick -0700"
191 GIT_AUTHOR_DATE="$test_tick -0700"
192 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
193 }
194
195 # You are not expected to call test_ok_ and test_failure_ directly, use
196 # the text_expect_* functions instead.
197
198 test_ok_ () {
199 test_count=$(expr "$test_count" + 1)
200 test_success=$(expr "$test_success" + 1)
201 say_color "" " ok $test_count: $@"
202 }
203
204 test_failure_ () {
205 test_count=$(expr "$test_count" + 1)
206 test_failure=$(expr "$test_failure" + 1);
207 say_color error "FAIL $test_count: $1"
208 shift
209 echo "$@" | sed -e 's/^/ /'
210 test "$immediate" = "" || { trap - exit; exit 1; }
211 }
212
213 test_known_broken_ok_ () {
214 test_count=$(expr "$test_count" + 1)
215 test_fixed=$(($test_fixed+1))
216 say_color "" " FIXED $test_count: $@"
217 }
218
219 test_known_broken_failure_ () {
220 test_count=$(expr "$test_count" + 1)
221 test_broken=$(($test_broken+1))
222 say_color skip " still broken $test_count: $@"
223 }
224
225 test_debug () {
226 test "$debug" = "" || eval "$1"
227 }
228
229 test_run_ () {
230 eval >&3 2>&4 "$1"
231 eval_ret="$?"
232 return 0
233 }
234
235 test_skip () {
236 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
237 this_test="$this_test.$(expr "$test_count" + 1)"
238 to_skip=
239 for skp in $GIT_SKIP_TESTS
240 do
241 case "$this_test" in
242 $skp)
243 to_skip=t
244 esac
245 done
246 case "$to_skip" in
247 t)
248 say_color skip >&3 "skipping test: $@"
249 test_count=$(expr "$test_count" + 1)
250 say_color skip "skip $test_count: $1"
251 : true
252 ;;
253 *)
254 false
255 ;;
256 esac
257 }
258
259 test_expect_failure () {
260 test "$#" = 2 ||
261 error "bug in the test script: not 2 parameters to test-expect-failure"
262 if ! test_skip "$@"
263 then
264 say >&3 "checking known breakage: $2"
265 test_run_ "$2"
266 if [ "$?" = 0 -a "$eval_ret" = 0 ]
267 then
268 test_known_broken_ok_ "$1"
269 else
270 test_known_broken_failure_ "$1"
271 fi
272 fi
273 echo >&3 ""
274 }
275
276 test_expect_success () {
277 test "$#" = 2 ||
278 error "bug in the test script: not 2 parameters to test-expect-success"
279 if ! test_skip "$@"
280 then
281 say >&3 "expecting success: $2"
282 test_run_ "$2"
283 if [ "$?" = 0 -a "$eval_ret" = 0 ]
284 then
285 test_ok_ "$1"
286 else
287 test_failure_ "$@"
288 fi
289 fi
290 echo >&3 ""
291 }
292
293 test_expect_code () {
294 test "$#" = 3 ||
295 error "bug in the test script: not 3 parameters to test-expect-code"
296 if ! test_skip "$@"
297 then
298 say >&3 "expecting exit code $1: $3"
299 test_run_ "$3"
300 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
301 then
302 test_ok_ "$2"
303 else
304 test_failure_ "$@"
305 fi
306 fi
307 echo >&3 ""
308 }
309
310 # test_external runs external test scripts that provide continuous
311 # test output about their progress, and succeeds/fails on
312 # zero/non-zero exit code. It outputs the test output on stdout even
313 # in non-verbose mode, and announces the external script with "* run
314 # <n>: ..." before running it. When providing relative paths, keep in
315 # mind that all scripts run in "trash directory".
316 # Usage: test_external description command arguments...
317 # Example: test_external 'Perl API' perl ../path/to/test.pl
318 test_external () {
319 test "$#" -eq 3 ||
320 error >&5 "bug in the test script: not 3 parameters to test_external"
321 descr="$1"
322 shift
323 if ! test_skip "$descr" "$@"
324 then
325 # Announce the script to reduce confusion about the
326 # test output that follows.
327 say_color "" " run $(expr "$test_count" + 1): $descr ($*)"
328 # Run command; redirect its stderr to &4 as in
329 # test_run_, but keep its stdout on our stdout even in
330 # non-verbose mode.
331 "$@" 2>&4
332 if [ "$?" = 0 ]
333 then
334 test_ok_ "$descr"
335 else
336 test_failure_ "$descr" "$@"
337 fi
338 fi
339 }
340
341 # Like test_external, but in addition tests that the command generated
342 # no output on stderr.
343 test_external_without_stderr () {
344 # The temporary file has no (and must have no) security
345 # implications.
346 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
347 stderr="$tmp/git-external-stderr.$$.tmp"
348 test_external "$@" 4> "$stderr"
349 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
350 descr="no stderr: $1"
351 shift
352 say >&3 "expecting no stderr from previous command"
353 if [ ! -s "$stderr" ]; then
354 rm "$stderr"
355 test_ok_ "$descr"
356 else
357 if [ "$verbose" = t ]; then
358 output=`echo; echo Stderr is:; cat "$stderr"`
359 else
360 output=
361 fi
362 # rm first in case test_failure exits.
363 rm "$stderr"
364 test_failure_ "$descr" "$@" "$output"
365 fi
366 }
367
368 # This is not among top-level (test_expect_success | test_expect_failure)
369 # but is a prefix that can be used in the test script, like:
370 #
371 # test_expect_success 'complain and die' '
372 # do something &&
373 # do something else &&
374 # test_must_fail git checkout ../outerspace
375 # '
376 #
377 # Writing this as "! git checkout ../outerspace" is wrong, because
378 # the failure could be due to a segv. We want a controlled failure.
379
380 test_must_fail () {
381 "$@"
382 test $? -gt 0 -a $? -le 129
383 }
384
385 # test_cmp is a helper function to compare actual and expected output.
386 # You can use it like:
387 #
388 # test_expect_success 'foo works' '
389 # echo expected >expected &&
390 # foo >actual &&
391 # test_cmp expected actual
392 # '
393 #
394 # This could be written as either "cmp" or "diff -u", but:
395 # - cmp's output is not nearly as easy to read as diff -u
396 # - not all diff versions understand "-u"
397
398 test_cmp() {
399 $GIT_TEST_CMP "$@"
400 }
401
402 # Most tests can use the created repository, but some may need to create more.
403 # Usage: test_create_repo <directory>
404 test_create_repo () {
405 test "$#" = 1 ||
406 error "bug in the test script: not 1 parameter to test-create-repo"
407 owd=`pwd`
408 repo="$1"
409 mkdir "$repo"
410 cd "$repo" || error "Cannot setup test environment"
411 "$GIT_EXEC_PATH/git" init "--template=$GIT_EXEC_PATH/templates/blt/" >&3 2>&4 ||
412 error "cannot run git init -- have you built things yet?"
413 mv .git/hooks .git/hooks-disabled
414 cd "$owd"
415 }
416
417 test_done () {
418 trap - exit
419 test_results_dir="$TEST_DIRECTORY/test-results"
420 mkdir -p "$test_results_dir"
421 test_results_path="$test_results_dir/${0%-*}-$$"
422
423 echo "total $test_count" >> $test_results_path
424 echo "success $test_success" >> $test_results_path
425 echo "fixed $test_fixed" >> $test_results_path
426 echo "broken $test_broken" >> $test_results_path
427 echo "failed $test_failure" >> $test_results_path
428 echo "" >> $test_results_path
429
430 if test "$test_fixed" != 0
431 then
432 say_color pass "fixed $test_fixed known breakage(s)"
433 fi
434 if test "$test_broken" != 0
435 then
436 say_color error "still have $test_broken known breakage(s)"
437 msg="remaining $(($test_count-$test_broken)) test(s)"
438 else
439 msg="$test_count test(s)"
440 fi
441 case "$test_failure" in
442 0)
443 # We could:
444 # cd .. && rm -fr 'trash directory'
445 # but that means we forbid any tests that use their own
446 # subdirectory from calling test_done without coming back
447 # to where they started from.
448 # The Makefile provided will clean this test area so
449 # we will leave things as they are.
450
451 say_color pass "passed all $msg"
452 exit 0 ;;
453
454 *)
455 say_color error "failed $test_failure among $msg"
456 exit 1 ;;
457
458 esac
459 }
460
461 # Test the binaries we have just built. The tests are kept in
462 # t/ subdirectory and are run in 'trash directory' subdirectory.
463 TEST_DIRECTORY=$(pwd)
464 PATH=$TEST_DIRECTORY/..:$PATH
465 GIT_EXEC_PATH=$(pwd)/..
466 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
467 unset GIT_CONFIG
468 unset GIT_CONFIG_LOCAL
469 GIT_CONFIG_NOSYSTEM=1
470 GIT_CONFIG_NOGLOBAL=1
471 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
472
473 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
474 export GITPERLLIB
475 test -d ../templates/blt || {
476 error "You haven't built things yet, have you?"
477 }
478
479 if ! test -x ../test-chmtime; then
480 echo >&2 'You need to build test-chmtime:'
481 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
482 exit 1
483 fi
484
485 . ../GIT-BUILD-OPTIONS
486
487 # Test repository
488 test="trash directory"
489 rm -fr "$test" || {
490 trap - exit
491 echo >&5 "FATAL: Cannot prepare test area"
492 exit 1
493 }
494
495 test_create_repo "$test"
496 # Use -P to resolve symlinks in our working directory so that the cwd
497 # in subprocesses like git equals our $PWD (for pathname comparisons).
498 cd -P "$test" || exit 1
499
500 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
501 for skp in $GIT_SKIP_TESTS
502 do
503 to_skip=
504 for skp in $GIT_SKIP_TESTS
505 do
506 case "$this_test" in
507 $skp)
508 to_skip=t
509 esac
510 done
511 case "$to_skip" in
512 t)
513 say_color skip >&3 "skipping test $this_test altogether"
514 say_color skip "skip all tests in $this_test"
515 test_done
516 esac
517 done